unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

const
 MaxN=600;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TPoint = record
   X,Y:Real;
   pX,pY:Real;
   Charge,Mass:Real;
  end;

  TPoints = array[1..MaxN] of TPoint;

var
  Form1: TForm1;
  Points:TPoints;
  t,dt:Real;
  cF:Real;
  n:Integer;
  Count:Integer;

implementation

uses
 DialUnit;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
 i:Integer;
 r,fi:Single;
begin
 Randomize;
 n:=20;
 {for i:=1 to n do
 begin
  Points[i].X:=400 + Random(300) - Random(300);
  Points[i].Y:=400 + Random(300) - Random(300);
  Points[i].pX:=(Random(300) - Random(300))/300;
  Points[i].pY:=(Random(300) - Random(300))/300;
  Points[i].Mass:=1;
  if Odd(Random(10000)) then
   Points[i].Charge:=1
  else
   Points[i].Charge:=-1;
 end;}
 {First particle}
 for i:=1 to n do
 begin
  r:=Random(200);
  fi:=2*pi*Random(5000)/5000;
  Points[i].Mass:=1; Points[i].Charge:=1;
  Points[i].X:=400 + r*sin(fi); Points[i].Y:=300 + r*cos(fi);
  Points[i].pX:=0.1*r*sin(fi) + 0.1*r*cos(fi); Points[i].pY:=0.1*r*cos(fi) - 0.1*r*sin(fi);
 end;
 {Second particle}
 {Points[2].Mass:=100; Points[2].Charge:=10;
 Points[2].X:=400; Points[2].Y:=300;
 Points[2].pX:=0; Points[2].pY:=0;}
 {Acting coefficients}
 cF:=-1000;
 t:=0;
 dt:=0.05;
 Timer1.Enabled:=True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
 i,j:Integer;
 dX,dY,dR,dR2:Real;
 Fx,Fy:Real;
 grX,grY:Integer;
begin
 for i:=1 to n do
 begin
  Fx:=0; Fy:=0;
  for j:=1 to n do
   if j<>i then
   begin
    dX:=Points[i].X - Points[j].X;
    dY:=Points[i].Y - Points[j].Y;
    dR2:=dX*dX + dY*dY;
    dR:=Sqrt(dR2);
    Fx:=Fx + cF*Points[i].Charge*Points[j].Charge*dX/(dR*dR2);
    Fy:=Fy + cF*Points[i].Charge*Points[j].Charge*dY/(dR*dR2);
   end;
   Fx:=Fx/Points[i].Mass;
   Fy:=Fy/Points[i].Mass;
   Points[i].pX:=Points[i].pX + Fx*dt;
   Points[i].pY:=Points[i].pY + Fy*dt;
   Points[i].X:=Points[i].X + Points[i].pX*dt;
   Points[i].Y:=Points[i].Y + Points[i].pY*dt;
 end;
 for i:=1 to n do
 begin
  grX:=Round(Points[i].X);
  grY:=Round(Points[i].Y);
  if (((grX<800) and (grX>0)) and ((grY<600) and (grY>0))) then
  begin
   Form1.Canvas.Pixels[grX,grY]:=clWhite
  end;
 end;
 t:=t + dt;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Timer1.Enabled:=not Timer1.Enabled;
 if Timer1.Enabled then
  Button2.Caption:='Stop'
 else
  Button2.Caption:='Continue'
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 Form1.Close;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
 S:String;
begin
 Inc(Count);
 S:=IntToStr(Count);
 Button1.Caption:='Start ' + S;
 Points[Count].X:=X;
 Points[Count].X:=Y;
 Form3.Visible:=True;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
 i,j:Integer;
begin
 for j:=1 to 60 do
 begin
  Points[1].Mass:=1;    Points[1].Charge:=1;
  Points[1].X:=10;      Points[1].Y:=300 + 6*(j-30);
  Points[1].pX:=200;    Points[1].pY:=0;
  Points[2].Mass:=10000;  Points[2].Charge:=10;
  Points[2].X:=400;     Points[2].Y:=300;
  Points[2].pX:=0;      Points[2].pY:=0;
  for i:=1 to 1000 do
   Timer1.OnTimer(Self);
 end;
end;

initialization
begin
 Count:=0;
end;

end.
